type op = Add | Subtract |  Multipy | Divide 
        | Equal | Neq | Less | Leq | Greater | Geq

type note = 
    Note of int

type rhythm = 
    Rhythm of int
  
type expr =
    Literal of int
  | Id of string
  | Note of int
  | Rhythm of int
  | Binop of expr * op * expr
  | Assign of string * expr
  | Call of string * expr list
  | Noexpr

type stmt =
    Block of stmt list
  | Expr of expr
  | Return of expr
  | If of expr * stmt * stmt
  | For of expr * expr * expr * stmt
  | While of expr * stmt
    
type func_decl = {
    fname : string;
    formals : string list;
    locals : string list;
    body : stmt list;
  }

type program = string list * func_decl list